{**
 DelphiPI (Delphi Package Installer)
 Author  : ibrahim dursun (t-hex) thex [at] thexpot ((dot)) net
 License : GNU General Public License 2.0
**}
unit PageAlarmODBC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PageBase, StdCtrls, ExtCtrls, WizardIntfs, JclBorlandTools, ActnList,
  DB, ADODB,ComCtrls, PrnDbgeh, GridsEh, DBGridEh,EhLibMTE,EhLibADO;
type
  TFrmAlarmODBC = class(TWizardPage)
    dsDetail: TDataSource;
    adoConn: TADOConnection;
    tabDetail: TADOQuery;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    btnRefresh: TButton;
    edtTM1: TDateTimePicker;
    edtTM2: TDateTimePicker;
    grdDetail: TDBGridEh;
    prtDetail: TPrintDBGridEh;
    chkFilter: TCheckBox;
    chkDetail: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure chkFilterClick(Sender: TObject);
    procedure grdDetailSumListAfterRecalcAll(Sender: TObject);
    procedure edtTM1Click(Sender: TObject);
  private
    procedure Preview(Sender:TObject);
  public
    procedure UpdateWizardState; override;
  end;

implementation

uses gnugettext, FormWizard,Registry,Utils,JCLFileUtils;
{$R *.dfm}

procedure TFrmAlarmODBC.btnRefreshClick(Sender: TObject);
const Summary='SELECT ؿʼʱ as ʱ,߼ڵ, ǩ,Ϣ'+
  ', Ϣ, ȼ'+
  //',Count(Ϣ) AS  '+
  ' FROM FIXALARMS'+
  ' where (  ؿʼʱ >= :TM1 )and (  ؿʼʱ < :TM2 )'+
  'GROUP BY ؿʼʱ,߼ڵ, ǩ, Ϣ,Ϣ, ȼ ';
  Detail='select ؿʼʱ as ʼʱ,ؽʱ as ʱ'+
  ',߼ڵ,ǩ,ǩ,Ϣ ,Ϣ,״̬,ȼ'+
  ',,Ա¼û as û'+
  ' from fixalarms '+
  ' where (  ؿʼʱ >= :TM1 )and (  ؿʼʱ < :TM2 )'+
  ' order by ؽʱ desc';
begin
  if tabDetail.Active  then tabDetail.Active := not tabDetail.Active ;
  if chkDetail.Checked
   then tabDetail.SQL.Text:=Detail
   else tabDetail.SQL.Text:=Summary;
  with tabDetail.Parameters.ParamByName('TM2') do begin
   DataType:=ftDateTime;
   Value:=Int(edtTM2.Date+1);
  end;
  with tabDetail.Parameters.ParamByName('TM1') do begin
   DataType:=ftDateTime;
   Value:=Int(edtTM1.Date);
  end;
  tabDetail.Active:=not tabDetail.Active;
  UpdateWizardState;
  btnRefresh.Enabled:=false;
end;

procedure TFrmAlarmODBC.chkFilterClick(Sender: TObject);
begin
  grdDetail.STFilter.Visible:=chkFilter.Checked;
end;

procedure TFrmAlarmODBC.edtTM1Click(Sender: TObject);
begin
 btnRefresh.Enabled:=true;
end;

procedure TFrmAlarmODBC.FormCreate(Sender: TObject);
begin
 wizard.SetHeader(_('History Alarm List'));
 ShowInfo('');
 //TP_Ignore(self,'.font');
 TranslateComponent(self);
 if adoConn.Connected
  then adoConn.Connected:=false;
 adoConn.ConnectionString:=Wizard.GetStateValue('ConnStr');
 edtTM1.Date:=Now-30;
 edtTM2.Date:=Now;
end;

procedure TFrmAlarmODBC.grdDetailSumListAfterRecalcAll(Sender: TObject);
begin
 if grdDetail.Columns.Count<2 then exit;
 with grdDetail.Columns[0] do begin
  Footer.ValueType:=fvtStaticText;
  Footer.Value:=_('Records:');
 end;
 with grdDetail.Columns[1] do begin
  Footer.ValueType:=fvtCount;
  Footer.FieldName:=FieldName;
 end;
end;

procedure TFrmAlarmODBC.Preview(Sender: TObject);
begin
 if tabdetail.Active
  then prtDetail.Preview
  else btnRefreshClick(btnRefresh);
end;

procedure TFrmAlarmODBC.UpdateWizardState;
var
  action: TAction;
begin
  action:=wizard.GetAction(wbtback);
  action.Enabled:=true;
  if self.tabDetail.Active
   then action.Caption:=_('&Print')
   else action.Caption:=_('&Active');
  action.OnExecute:=Preview;
  wizard.GetAction(wbtNext);
  action := wizard.GetAction(wbtNext);
  action.Caption:=_('&Finished');
  action.Enabled :=true;
end;

end.
