{**
 DelphiPI (Delphi Package Installer)
 Author  : ibrahim dursun (t-hex) thex [at] thexpot ((dot)) net
 License : GNU General Public License 2.0
**}
unit PageHisData;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PageBase, StdCtrls, ExtCtrls, WizardIntfs, JclBorlandTools, ActnList,
  DB, ADODB,ComCtrls, PrnDbgeh, GridsEh, DBGridEh,EhLibMTE,EhLibADO;
type
  TFrmHisData = class(TWizardPage)
    dsCHRPT: TDataSource;
    adoConn: TADOConnection;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    btnRefresh: TButton;
    edtTM1: TDateTimePicker;
    edtTM2: TDateTimePicker;
    prtDetail: TPrintDBGridEh;
    chkFilter: TCheckBox;
    Label3: TLabel;
    tabCHRPT: TADOQuery;
    tabCZRPT: TADOQuery;
    pg: TPageControl;
    TabSheet1: TTabSheet;
    grdCHRPT: TDBGridEh;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    dsCZRPT: TDataSource;
    grdCZRPT: TDBGridEh;
    grdSJTJ: TDBGridEh;
    dsSJTJ: TDataSource;
    tabSJTJ: TADOQuery;
    tabSJTJDT: TDateTimeField;
    tabSJTJYLBSJ11: TIntegerField;
    tabSJTJYLBSJ12: TIntegerField;
    tabSJTJYLBSJ21: TIntegerField;
    tabSJTJYLBSJ22: TIntegerField;
    tabSJTJLZBSJ1: TIntegerField;
    tabSJTJLZBSJ2: TIntegerField;
    tabSJTJPWBSJ1: TIntegerField;
    tabSJTJPWBSJ2: TIntegerField;
    tabSJTJNJBSJ1: TIntegerField;
    tabSJTJNJBSJ2: TIntegerField;
    tabSJTJNJBSJ3: TIntegerField;
    tabSJTJNJBSJ4: TIntegerField;
    procedure FormCreate(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure chkFilterClick(Sender: TObject);
    procedure edtTM1Click(Sender: TObject);
    procedure TabSheet1Show(Sender: TObject);
    procedure TabSheet1Hide(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure TabSheet2Hide(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure TabSheet3Hide(Sender: TObject);
    procedure tabSJTJYLBSJ11GetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
  private
    function CurDataSet:TDataSet;
    procedure Preview(Sender:TObject);
    procedure OpenTable;
  public
    procedure UpdateWizardState; override;
  end;

implementation

uses gnugettext, FormWizard,Registry,Utils,JCLFileUtils;
{$R *.dfm}

procedure TFrmHisData.OpenTable;
var
 TM1,TM2:TDatetime;
begin
 if CurDataSet=nil then exit;
 if CurDataSet.Active  then CurDataSet.Active:=false;
 TM1:=Int(edtTM1.DateTime);
 TM2:=Int(edtTM2.DateTime)+1;
 with (CurDataSet as TADOQuery).Parameters
  do begin
   ParamByName('TM2').Value:=TM2;
   ParamByName('TM1').Value:=TM1;
  end;
 CurDataSet.Active:=true; 
 UpdateWizardState;
 btnRefresh.Enabled:=false;
end;

function TFrmHisData.CurDataSet: TDataSet;
begin
 result:=nil;
 if assigned(prtDetail.DBGridEh)
  then result:=prtDetail.DBGridEh.DataSource.DataSet;
end;

procedure TFrmHisData.btnRefreshClick(Sender: TObject);
begin
  OpenTable;
end;

procedure TFrmHisData.chkFilterClick(Sender: TObject);
begin
  if not Assigned(prtDetail.DBGridEh) then exit;
  prtDetail.DBGridEh.STFilter.Visible:=chkFilter.Checked;
end;

procedure TFrmHisData.edtTM1Click(Sender: TObject);
begin
 btnRefresh.Enabled:=true;
end;

procedure TFrmHisData.FormCreate(Sender: TObject);
begin
 wizard.SetHeader(_('Data list'));
 ShowInfo('');
 TranslateComponent(self);
 if adoConn.Connected
  then adoConn.Connected:=false;
 adoConn.ConnectionString:=Wizard.GetStateValue('ConnStr');
 edtTM1.DateTime:=Date-30;
 edtTM2.DateTime:=Date;
 pg.ActivePage:=self.TabSheet1;
 prtDetail.DBGridEh:=grdCHRPT;  
 grdCHRPT.STFilter.Visible:=chkFilter.Checked;
end;

procedure TFrmHisData.Preview(Sender: TObject);
begin
 if CurDataSet=nil then exit;
 prtDetail.PageFooter.RightText.Text:=FormatDateTime('yyyyMMddhh:mm:ss',Now);
 prtDetail.PageFooter.LeftText.Text:=PRTTitle; 
 if CurDataSet.Active
  then prtDetail.Preview
  else btnRefreshClick(btnRefresh);
end;

procedure TFrmHisData.TabSheet1Hide(Sender: TObject);
begin
 tabCHRPT.Active:=false;
end;

procedure TFrmHisData.TabSheet1Show(Sender: TObject);
begin
  prtDetail.DBGridEh:=grdCHRPT;
  prtDetail.PageHeader.CenterText.Text:=PRTTitle+'  ';
  prtDetail.DBGridEh.STFilter.Visible:=chkFilter.Checked;
  OpenTable;
end;

procedure TFrmHisData.TabSheet2Hide(Sender: TObject);
begin
 tabCZRPT.Active:=false;
end;

procedure TFrmHisData.TabSheet2Show(Sender: TObject);
begin
  prtDetail.DBGridEh:=grdCZRPT;
  prtDetail.PageHeader.CenterText.Text:=PRTTitle+'  ˮ';
  prtDetail.DBGridEh.STFilter.Visible:=chkFilter.Checked;
  OpenTable;
end;

procedure TFrmHisData.TabSheet3Hide(Sender: TObject);
begin
 tabSJTJ.Active:=false;
end;

procedure TFrmHisData.TabSheet3Show(Sender: TObject);
begin       
  prtDetail.DBGridEh:=grdSJTJ;
  prtDetail.PageHeader.CenterText.Text:=PRTTitle+'  豸ʱͳ';
  prtDetail.DBGridEh.STFilter.Visible:=chkFilter.Checked;
  OpenTable;
end;

procedure TFrmHisData.tabSJTJYLBSJ11GetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
var
 dd,hh,mm:Integer;
 iValue:Integer;
begin
  iValue:=Sender.AsInteger;
  dd:=iValue div 1440;
  iValue:=iValue mod 1440;
  hh:=iValue div 60;
  mm:=iValue mod 60;
  if dd>0
   then Text:=format('%d%.2d:%.2d',[dd,hh,mm])
   else Text:=format('%.2d:%.2d',[hh,mm]);
end;

procedure TFrmHisData.UpdateWizardState;
var
  action: TAction;
begin
  action:=wizard.GetAction(wbtback);
  action.Enabled:=true;
  if CurDataSet.Active
   then begin
    action.Caption:=_('&Print');
    action.Enabled:=CurDataSet.RecordCount>0;
   end
   else action.Caption:=_('&Active');
  action.OnExecute:=Preview;
  wizard.GetAction(wbtNext);
  action := wizard.GetAction(wbtNext);
  action.Enabled :=true;
end;

end.
