unit Utils;

interface


uses classes;

const
  VERSION = '1.00';

  DELPHI_VERSION_UNKNOWN = -1;
  DELPHI_VERSION_5 = 0;
  DELPHI_VERSION_6 = 1;
  DELPHI_VERSION_7 = 2;
  DELPHI_VERSION_8 = 3;
  DELPHI_VERSION_2005 = 4;
  DELPHI_VERSION_2006 = 5;
  DELPHI_VERSION_2007 = 6;
  DELPHI_VERSION_2009 = 7;
  DELPHI_VERSION_2010 = 8;
  VersionNames: array[DELPHI_VERSION_UNKNOWN..DELPHI_VERSION_2010] of string = ('Unknown', 'Delphi 5','Delphi 6','Delphi 7','Delphi 8','Delphi 2005', 'Delphi 2006', 'Delphi 2007','Delphi 2009','Delphi 2010');
  PRTTitle='ϵͳ־';
type
  TDelphiVersionArray = array[DELPHI_VERSION_5..DELPHI_VERSION_2010] of TStringList;

function CreateConnStr(const dbName,UserName,Password:string):string;

function LoadResourceToStream(ResName: PChar; Stream: TStream): Boolean;

function LoadResourceToFile(ResName: string; FileName:string): Boolean;

var
  CODE:string ;
  AUTHOR:string;

implementation

uses windows,SysUtils,JCLFileUtils,gnugettext;

function CreateConnStr(const dbName,UserName,Password:string):string;
const
 fmtConn='Provider=Microsoft.Jet.OLEDB.4.0;'
   +'Data Source=%s;Persist Security Info=True;';
 fmtUsr=' User Id =%s;';
 fmtPwd=' Password=%s;';
var
 Usr,Pwd:string;
begin
 result:=format(fmtConn,[dbName]);
 Usr:=trim(UserName);
 if Usr<>'' then begin
  result:=result+format(fmtUsr,[Usr]);
 end;
 Pwd:=trim(Password);
 if Pwd<>'' then begin
  result:=result+format(fmtPwd,[Pwd]);
 end;
end;

function LoadResourceToStream(ResName :PChar;Stream: TStream): Boolean;
var
  ResSrc: hRSrc;
  ResGlobal: hGlobal;
  ResAddr: Pointer;
  ResLength: DWord;
begin
  Result := False;
  if Stream = nil then Exit;

  ResSrc := FindResource(0, ResName,RT_RCDATA);
  if ResSrc = 0 then Exit;
  ResGlobal := LoadResource(0, ResSrc);
  if ResGlobal = 0 then Exit;
  ResAddr := LockResource(ResGlobal);
  FreeResource(ResGlobal);
  if ResAddr = nil then Exit;

  ResLength := SizeOfResource(0, ResSrc);
  if ResLength = 0 then Exit;

  try
    Stream.WriteBuffer(ResAddr^, ResLength);
    Result := True;
  except
  end;
end;

function LoadResourceToFile(ResName: string; FileName:string): Boolean;
 var
  fs: TFileStream;
 begin
  result:=false;
  if FileExists(FileName) then exit;
  try
   fs:=TFileStream.Create(FileName,fmCreate or fmShareDenyNone);
   try
    result:=LoadResourceToStream(PChar(ResName),fs);
   finally;
    fs.Free;
    if not result then FileDelete(FileName);
   end;
  except
  end;
end;

initialization
  CODE :=_('Ri.shun.xue');
  AUTHOR := _('Longking');

end.
